(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("snoopy", [], factory);
	else if(typeof exports === 'object')
		exports["snoopy"] = factory();
	else
		root["snoopy"] = factory();
})(typeof self !== 'undefined' ? self : this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 2);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

// Unique ID creation requires a high quality random # generator.  In the
// browser this is a little complicated due to unknown quality of Math.random()
// and inconsistent support for the `crypto` API.  We do the best we can via
// feature-detection

// getRandomValues needs to be invoked in a context where "this" is a Crypto
// implementation. Also, find the complete implementation of crypto on IE11.
var getRandomValues = (typeof(crypto) != 'undefined' && crypto.getRandomValues && crypto.getRandomValues.bind(crypto)) ||
                      (typeof(msCrypto) != 'undefined' && typeof window.msCrypto.getRandomValues == 'function' && msCrypto.getRandomValues.bind(msCrypto));

if (getRandomValues) {
  // WHATWG crypto RNG - http://wiki.whatwg.org/wiki/Crypto
  var rnds8 = new Uint8Array(16); // eslint-disable-line no-undef

  module.exports = function whatwgRNG() {
    getRandomValues(rnds8);
    return rnds8;
  };
} else {
  // Math.random()-based (RNG)
  //
  // If all else fails, use Math.random().  It's fast, but is of unspecified
  // quality.
  var rnds = new Array(16);

  module.exports = function mathRNG() {
    for (var i = 0, r; i < 16; i++) {
      if ((i & 0x03) === 0) r = Math.random() * 0x100000000;
      rnds[i] = r >>> ((i & 0x03) << 3) & 0xff;
    }

    return rnds;
  };
}


/***/ }),
/* 1 */
/***/ (function(module, exports) {

/**
 * Convert array of 16 byte values to UUID string format of the form:
 * XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX
 */
var byteToHex = [];
for (var i = 0; i < 256; ++i) {
  byteToHex[i] = (i + 0x100).toString(16).substr(1);
}

function bytesToUuid(buf, offset) {
  var i = offset || 0;
  var bth = byteToHex;
  // join used to fix memory issue caused by concatenation: https://bugs.chromium.org/p/v8/issues/detail?id=3175#c4
  return ([bth[buf[i++]], bth[buf[i++]], 
	bth[buf[i++]], bth[buf[i++]], '-',
	bth[buf[i++]], bth[buf[i++]], '-',
	bth[buf[i++]], bth[buf[i++]], '-',
	bth[buf[i++]], bth[buf[i++]], '-',
	bth[buf[i++]], bth[buf[i++]],
	bth[buf[i++]], bth[buf[i++]],
	bth[buf[i++]], bth[buf[i++]]]).join('');
}

module.exports = bytesToUuid;


/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _uuid = __webpack_require__(3);

var _browser = __webpack_require__(6);

var _browser2 = _interopRequireDefault(_browser);

var _cookies = __webpack_require__(7);

var _cookies2 = _interopRequireDefault(_cookies);

var _googleAnalytics = __webpack_require__(8);

var _googleAnalytics2 = _interopRequireDefault(_googleAnalytics);

var _utils = __webpack_require__(9);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var plugins = {
  browser: _browser2.default,
  cookies: _cookies2.default,
  googleAnalytics: _googleAnalytics2.default
};
Object.freeze(plugins);


var instance = null;

/**
 * Class for aynchronously sending event information to a tracker URL
 * @function
 * @param {string} name - event name
 * @param {string} trackerURL - URL to which event information is to be sent
 * @param {object} [options] = {} - object containing request options
 */

var Snoopy = function () {
  // TODO: define options keys
  function Snoopy(name, trackerURL) {
    var _this = this;

    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    _classCallCheck(this, Snoopy);

    this.name = name;
    this.trackerURL = trackerURL;
    this.options = options;
    this.globals = {};
    this.plugins = { before: {}, after: {} };

    if (this.options.hasOwnProperty('disabledPlugins')) {
      this.disabledPlugins = options.disabledPlugins;
    } else {
      this.disabledPlugins = {};
    }

    plugins.forEachSpecial(function (Plugin, key) {
      if (!_this.disabledPlugins.hasOwnProperty(key)) {
        var p = new Plugin(_this);
        if (p.hasOwnProperty('order')) {
          if (p.order === 'before') {
            _this.plugins.before[key] = p;
          } else {
            _this.plugins.after[key] = p;
          }
        } else {
          _this.plugins.before[key] = p;
        }
      }
    });

    if (!instance) {
      instance = this;
    }
    return instance;
  }

  /**
   * Allows setting of global parameters that will be included with every event;
   * global settings will overwrite existing params if their key exists
   * @param {object} Obj of key/values to insert into the global parameters for events
   * @throws {Error} if input parameter isn't an object
   * @returns {boolean} True if input was accepted and set in the globals object, never False
   */


  _createClass(Snoopy, [{
    key: 'set',
    value: function set(kv) {
      if (!(0, _utils.isObject)(kv)) throw Error('Invalid object');
      this.globals = (0, _utils.mergeDeep)(this.globals, kv);
    }

    /**
     * Allows removing global params by specifying path.
     * Warning: Removing a parent node will remove all children.
     * @param  {string} path - 'key1.key2.key3.key4'
     *          string literal path delimited by '.' of a key you'd like to delete
     */

  }, {
    key: 'unset',
    value: function unset(path) {
      (0, _utils.deepDelete)(path, this.globals);
    }

    /**
     * Gather and aynchronously send event information to the tracker URL
     * @function
     * @param {string} eventName
     * @param {string} eventCategory
     * @param {string} eventAction
     * @param {string} eventOrigin
     * @param {string} [eventLabel] = ''
     * @param {string} [eventValue] = ''
     * @param {string} [eventSchema] = 'latest'
     * @param {object} [data] = {} - Event object
     * @return {Promise}
     */

  }, {
    key: 'track',
    value: function track(eventName, eventCategory, eventAction, eventOrigin) {
      var eventLabel = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : '';
      var eventValue = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : '';

      var _this2 = this;

      var eventSchema = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : 'latest';
      var data = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : {};

      var eventData = Object.assign({
        eventCategory: eventCategory,
        eventAction: eventAction,
        eventLabel: eventLabel,
        eventValue: eventValue
      }, data, this.globals);

      var event = {
        eventTimestamp: (0, _utils.utc)(),
        eventUuid: (0, _uuid.v4)(),
        eventName: eventName,
        eventOrigin: eventOrigin || window.location.hostname,
        eventSchema: eventSchema,
        data: eventData
      };

      this.plugins.before.forEachSpecial(function (plugin) {
        event = plugin.callback(event);
      });

      this.plugins.after.forEachSpecial(function (plugin) {
        event = plugin.callback(event);
      });

      return new Promise(function (resolve, reject) {
        Snoopy.emit(event, _this2.trackerURL, _this2.options).then(function (xhr) {
          // success
          resolve([event, xhr]);
        }, function (xhr) {
          // failure
          reject([event, xhr]);
        });
      });
    }

    /**
     * Aynchronously send event information to the tracker URL
     * @function
     * @param {string} data - event object
     * @param {string} trackerURL - URL to which event information is to be sent
     * @param {object} options - object containing request options
     */

  }], [{
    key: 'emit',
    value: function emit(data, trackerURL, options) {
      return new Promise(function (resolve, reject) {
        var xhr = new XMLHttpRequest();
        xhr.open(options.method || 'POST', trackerURL);
        xhr.setRequestHeader('Content-Type', 'application/json');
        if (options.headers) {
          Object.keys(options.headers).forEachSpecial(function (key) {
            xhr.setRequestHeader(key, options.headers[key]);
          });
        }
        xhr.onload = function () {
          if (xhr.status >= 200 && xhr.status < 300) {
            resolve(xhr);
          } else {
            reject(xhr);
          }
        };
        xhr.onerror = function () {
          reject(xhr);
        };

        xhr.send(JSON.stringify(data));
      });
    }
  }]);

  return Snoopy;
}();

exports.default = Snoopy;

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

var v1 = __webpack_require__(4);
var v4 = __webpack_require__(5);

var uuid = v4;
uuid.v1 = v1;
uuid.v4 = v4;

module.exports = uuid;


/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

var rng = __webpack_require__(0);
var bytesToUuid = __webpack_require__(1);

// **`v1()` - Generate time-based UUID**
//
// Inspired by https://github.com/LiosK/UUID.js
// and http://docs.python.org/library/uuid.html

var _nodeId;
var _clockseq;

// Previous uuid creation time
var _lastMSecs = 0;
var _lastNSecs = 0;

// See https://github.com/broofa/node-uuid for API details
function v1(options, buf, offset) {
  var i = buf && offset || 0;
  var b = buf || [];

  options = options || {};
  var node = options.node || _nodeId;
  var clockseq = options.clockseq !== undefined ? options.clockseq : _clockseq;

  // node and clockseq need to be initialized to random values if they're not
  // specified.  We do this lazily to minimize issues related to insufficient
  // system entropy.  See #189
  if (node == null || clockseq == null) {
    var seedBytes = rng();
    if (node == null) {
      // Per 4.5, create and 48-bit node id, (47 random bits + multicast bit = 1)
      node = _nodeId = [
        seedBytes[0] | 0x01,
        seedBytes[1], seedBytes[2], seedBytes[3], seedBytes[4], seedBytes[5]
      ];
    }
    if (clockseq == null) {
      // Per 4.2.2, randomize (14 bit) clockseq
      clockseq = _clockseq = (seedBytes[6] << 8 | seedBytes[7]) & 0x3fff;
    }
  }

  // UUID timestamps are 100 nano-second units since the Gregorian epoch,
  // (1582-10-15 00:00).  JSNumbers aren't precise enough for this, so
  // time is handled internally as 'msecs' (integer milliseconds) and 'nsecs'
  // (100-nanoseconds offset from msecs) since unix epoch, 1970-01-01 00:00.
  var msecs = options.msecs !== undefined ? options.msecs : new Date().getTime();

  // Per 4.2.1.2, use count of uuid's generated during the current clock
  // cycle to simulate higher resolution clock
  var nsecs = options.nsecs !== undefined ? options.nsecs : _lastNSecs + 1;

  // Time since last uuid creation (in msecs)
  var dt = (msecs - _lastMSecs) + (nsecs - _lastNSecs)/10000;

  // Per 4.2.1.2, Bump clockseq on clock regression
  if (dt < 0 && options.clockseq === undefined) {
    clockseq = clockseq + 1 & 0x3fff;
  }

  // Reset nsecs if clock regresses (new clockseq) or we've moved onto a new
  // time interval
  if ((dt < 0 || msecs > _lastMSecs) && options.nsecs === undefined) {
    nsecs = 0;
  }

  // Per 4.2.1.2 Throw error if too many uuids are requested
  if (nsecs >= 10000) {
    throw new Error('uuid.v1(): Can\'t create more than 10M uuids/sec');
  }

  _lastMSecs = msecs;
  _lastNSecs = nsecs;
  _clockseq = clockseq;

  // Per 4.1.4 - Convert from unix epoch to Gregorian epoch
  msecs += 12219292800000;

  // `time_low`
  var tl = ((msecs & 0xfffffff) * 10000 + nsecs) % 0x100000000;
  b[i++] = tl >>> 24 & 0xff;
  b[i++] = tl >>> 16 & 0xff;
  b[i++] = tl >>> 8 & 0xff;
  b[i++] = tl & 0xff;

  // `time_mid`
  var tmh = (msecs / 0x100000000 * 10000) & 0xfffffff;
  b[i++] = tmh >>> 8 & 0xff;
  b[i++] = tmh & 0xff;

  // `time_high_and_version`
  b[i++] = tmh >>> 24 & 0xf | 0x10; // include version
  b[i++] = tmh >>> 16 & 0xff;

  // `clock_seq_hi_and_reserved` (Per 4.2.2 - include variant)
  b[i++] = clockseq >>> 8 | 0x80;

  // `clock_seq_low`
  b[i++] = clockseq & 0xff;

  // `node`
  for (var n = 0; n < 6; ++n) {
    b[i + n] = node[n];
  }

  return buf ? buf : bytesToUuid(b);
}

module.exports = v1;


/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

var rng = __webpack_require__(0);
var bytesToUuid = __webpack_require__(1);

function v4(options, buf, offset) {
  var i = buf && offset || 0;

  if (typeof(options) == 'string') {
    buf = options === 'binary' ? new Array(16) : null;
    options = null;
  }
  options = options || {};

  var rnds = options.random || (options.rng || rng)();

  // Per 4.4, set bits for version and `clock_seq_hi_and_reserved`
  rnds[6] = (rnds[6] & 0x0f) | 0x40;
  rnds[8] = (rnds[8] & 0x3f) | 0x80;

  // Copy bytes to buffer, if provided
  if (buf) {
    for (var ii = 0; ii < 16; ++ii) {
      buf[i + ii] = rnds[ii];
    }
  }

  return buf || bytesToUuid(rnds);
}

module.exports = v4;


/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Browser = function () {
  function Browser(tracker) {
    _classCallCheck(this, Browser);

    this.tracker = tracker;
    this.userAgent = this.getUserAgent();
    this.isMobile = this.detectMobile();
    this.browserName = this.detectBrowser();
    this.order = 'before';
    return this;
  }

  /** @returns string */


  _createClass(Browser, [{
    key: 'getUserAgent',
    value: function getUserAgent() {
      return typeof navigator !== 'undefined' && navigator.userAgent ? navigator.userAgent : '';
    }

    /** @returns boolean */

  }, {
    key: 'detectMobile',
    value: function detectMobile() {
      var isMobile = false;
      if (/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|ipad|iris|kindle|Android|Silk|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(this.getUserAgent())) {
        isMobile = true;
      }
      return isMobile;
    }

    /** @returns string */

  }, {
    key: 'detectBrowser',
    value: function detectBrowser() {
      var ua = this.getUserAgent();
      var tem = void 0; // FIXME: make this code more readable
      var M = ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];
      if (/trident/i.test(M[1])) {
        tem = /\brv[ :]+(\d+)/g.exec(ua) || [];
        if (tem && tem.length > 0) return 'IE ' + (tem[1] || '');
      }
      if (M[1] === 'Chrome') {
        tem = ua.match(/\b(OPR|Edge)\/(\d+)/);
        if (tem && tem.length > 0) return tem.slice(1).join(' ').replace('OPR', 'Opera');
      }
      M = M[2] ? [M[1], M[2]] : [navigator.appName, navigator.appVersion, '-?'];
      if (tem && tem.length > 0 && ua.match(/version\/(\d+)/i) != null) M.splice(1, 1, tem[1]);
      return M.join(' ');
    }
  }, {
    key: 'getBrowser',
    value: function getBrowser() {
      var browser = {};
      if (navigator) {
        browser = {
          appName: navigator.appName,
          userAgent: this.userAgent,
          isMobile: this.isMobile,
          language: navigator.language,
          platform: navigator.platform,
          browserName: this.browserName
        };
      }

      return browser;
    }
  }, {
    key: 'callback',
    value: function callback(event) {
      event.data.browser = this.getBrowser();
      return event;
    }
  }]);

  return Browser;
}();

exports.default = Browser;

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Cookies = function () {
  function Cookies(tracker) {
    _classCallCheck(this, Cookies);

    this.tracker = tracker;
    this.cookies = this.getCookies();
    this.order = 'after';
    return this;
  }

  _createClass(Cookies, [{
    key: 'getCookies',
    value: function getCookies() {
      var cookies = {};
      if (typeof document !== 'undefined') {
        var pairs = document.cookie.split(';');
        for (var i = 0; i < pairs.length; i += 1) {
          var pair = pairs[i].split('=');
          cookies[pair[0].trim()] = decodeURIComponent(pair[1]);
        }
      }
      return cookies;
    }
  }, {
    key: 'callback',
    value: function callback(event) {
      event.data.cookies = this.getCookies();
      return event;
    }
  }]);

  return Cookies;
}();

exports.default = Cookies;

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Aynchronously send event information to the tracker URL
 * @function
 * @param {string} eventName
 * @param {string} eventCategory
 * @param {string} eventAction
 * @param {string} eventOrigin
 * @param {string} [eventLabel] = ''
 * @param {string} [eventValue] = ''
 * @param {string} [eventSchema] = 'latest'
 * @param {object} [data] = {} - Event object
 * @return {Promise}
 */
var GoogleAnalytics = function () {
  function GoogleAnalytics() {
    _classCallCheck(this, GoogleAnalytics);
  }

  _createClass(GoogleAnalytics, [{
    key: "callback",
    value: function callback(thisEvent) {
      window.dataLayer = window.dataLayer || [];
      var gaData = Object.assign({
        event: thisEvent.eventName,
        eventCategory: thisEvent.data.eventCategory,
        eventAction: thisEvent.data.eventAction,
        eventValue: thisEvent.data.eventValue,
        eventLabel: thisEvent.data.eventLabel,
        eventSchema: thisEvent.eventSchema,
        eventTimestamp: thisEvent.eventTimestamp,
        eventUuid: thisEvent.eventUuid,
        eventOrigin: thisEvent.eventOrigin
      }, thisEvent.data);
      window.dataLayer.push(gaData);
      return thisEvent;
    }
  }]);

  return GoogleAnalytics;
}();

exports.default = GoogleAnalytics;

/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.utc = utc;
exports.isObject = isObject;
exports.mergeDeep = mergeDeep;
exports.deepDelete = deepDelete;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function utc() {
  return Math.floor(new Date().getTime());
}

function isObject(item) {
  return item && (typeof item === 'undefined' ? 'undefined' : _typeof(item)) === 'object' && !Array.isArray(item);
}

function mergeDeep(target, source) {
  var output = Object.assign({}, target);
  if (isObject(target) && isObject(source)) {
    Object.keys(source).forEachSpecial(function (key) {
      if (isObject(source[key])) {
        if (!(key in target)) {
          Object.assign(output, _defineProperty({}, key, source[key]));
        } else {
          output[key] = mergeDeep(target[key], source[key]);
        }
      } else {
        Object.assign(output, _defineProperty({}, key, source[key]));
      }
    });
  }
  return output;
}

function deepDelete(path, context) {
  var targets = path.split('.');

  if (targets.length > 1) {
    deepDelete(targets.slice(1).join('.'), context[targets[0]]);
  } else {
    delete context[path];
  }
}

/**
 * Object.prototype.forEachSpecial() polyfill
 * https://gomakethings.com/looping-through-objects-with-es6/
 * @author Chris Ferdinandi
 * @license MIT
 */
if (!Object.prototype.forEachSpecial) {
  Object.defineProperty(Object.prototype, 'forEachSpecial', {
    value: function value(callback, thisArg) {
      if (this == null) {
        throw new TypeError('Not an object');
      }
      thisArg = thisArg || window;
      for (var key in this) {
        if (this.hasOwnProperty(key)) {
          callback.call(thisArg, this[key], key, this);
        }
      }
    }
  });
}

/***/ })
/******/ ]);
});
//# sourceMappingURL=snoopy.js.map